# pip download

Contents

- pip download
  - Usage
  - Description
    - Overview
  - Options
  - Examples

## Usage

    pip download [options] <requirement specifier> [package-index-options] ...
    pip download [options] -r <requirements file> [package-index-options] ...
    pip download [options] [-e] <vcs project url> ...
    pip download [options] [-e] <local project path> ...
    pip download [options] <archive url/path> ...

## Description

Download packages from:

- PyPI (and other indexes) using requirement specifiers.
- VCS project urls.
- Local project directories.
- Local or remote source archives.

pip also supports downloading from "requirements files", which provide an easy way to specify a whole environment to be downloaded.

### Overview

`pip download` replaces the `--download` option to `pip install`, which is now deprecated and will be removed in pip 10.

`pip download` does the same resolution and downloading as `pip install`, but instead of installing the dependencies, it collects the downloaded distributions into the directory provided (defaulting to the current directory). This directory can later be passed as the value to `pip install --find-links` to facilitate offline or locked down package installation.

## Options

`-c````,` `--constraint``<file>`

  Constrain versions using the given constraints file. This option can be used multiple times.

`-e````,` `--editable``<path/url>`

  Install a project in editable mode (i.e. setuptools "develop mode") from a local project path or a VCS url.

`-r````,` `--requirement``<file>`

  Install from the given requirements file. This option can be used multiple times.

`-b````,` `--build``<dir>`

  Directory to unpack packages into and build in.

`--no-deps```

  Don't install package dependencies.

`--global-option``<options>`

  Extra global options to be supplied to the setup.py call before the install command.

`--no-binary``<format_control>`

  Do not use binary packages. Can be supplied multiple times, and each time adds to the existing value. Accepts either :all: to disable all binary packages, :none: to empty the set, or one or more package names with commas between them. Note that some packages are tricky to compile and may fail to install when this option is used on them.

`--only-binary``<format_control>`

  Do not use source packages. Can be supplied multiple times, and each time adds to the existing value. Accepts either :all: to disable all source packages, :none: to empty the set, or one or more package names with commas between them. Packages without binary distributions will fail to install when this option is used on them.

`--src``<dir>`

  Directory to check out editable projects into. The default in a virtualenv is "<venv path>/src". The default for global installs is "<current dir>/src".

`--pre```

  Include pre-release and development versions. By default, pip only finds stable versions.

`--no-clean```

  Don't clean up build directories.

`--require-hashes```

  Require a hash to check each requirement against, for repeatable installs. This option is implied when any package in a requirements file has a --hash option.

`-d````,` `--dest``<dir>`

  Download packages into <dir>.

`-i````,` `--index-url``<url>`

  Base URL of Python Package Index (default https://pypi.python.org/simple).

`--extra-index-url``<url>`

  Extra URLs of package indexes to use in addition to --index-url.

`--no-index```

  Ignore package index (only looking at --find-links URLs instead).

`-f````,` `--find-links``<url>`

  If a url or path to an html file, then parse for links to archives. If a local path or file:// url that's a directory, then look for archives in the directory listing.

`--process-dependency-links```

  Enable the processing of dependency links.

## Examples

1. Download a package and all of its dependencies

>     $ pip download SomePackage
>     $ pip download -d . SomePackage  # equivalent to above
>     $ pip download --no-index --find-links=/tmp/wheelhouse -d /tmp/otherwheelhouse SomePackage